/* Configuration dependencies */

#define NEWSLIB     "/var/lib/news"
#define NEWSARTS    "/var/spool/news"

/* System dependencies */

#define USE_MMAP /* if you can mmap for reading on a regular file */

#undef NO_POINTER_ARITH
/* Define this if you can't subtract arbitrary pointers, i.e.
   char *a, *b; int c;
   c=a-b; assert(b+c==a) would fail for some a,b. */

/* malloc optimization parm */
#define CHUNK 1024
/* must be >= PATH_MAX, should be >= avg header len */
#define NUMLEN 12 /* enough to hold an int in ascii */

/* Should not need to be configured below here */

#include <limits.h>
#ifndef PATH_MAX
#define PATH_MAX 256
#endif
#ifdef I_MMAN
#ifdef USE_MMAP
#include <sys/mman.h>
#endif
#endif

#include <fcntl.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <assert.h>

/* The overview format */
#define OV_SUBJECT 0
#define OV_FROM 1
#define OV_DATE 2
#define OV_MESSAGEID 3
#define OV_REFERENCES 4
#define OV_BYTES 5
#define OV_LINES 6
#define OV_XREF 7

/* Globals */
extern int tot_grp, tot_add, tot_exp;
extern int verbose;

/* Internal routines */
char *mkover(int art);
char dogroup(const char *gr, int mi, int ma, int ex, int ad);
int matches(char *grp, char *list[], int i);
void setsig(const char *f1);
void finish(int e);
void daemon(int secs);
void xo_close(void);
int xo_group(char *gr, int mi);
char *xo_xover(int n);
#ifdef USE_FLOCK
/* this doesn't work yet! */
extern inline int lock(void)   { return 0; }
extern inline int unlock(void) { return 0; }
#else
int lock(void);
int unlock(void);
#endif
