#include "common.h"

/* Update one group's overview file */

char 
dogroup(const char *gr, int mi, int ma, int ex, int ad)
{
	char buf[CHUNK];
	char b2[NUMLEN];
	char *p1 = strdup(gr);
	char *p2;
	char c;
	FILE *f1, *f2;
	struct stat st;
	int i, add = 0, cop = 0;

	if (!(p2 = p1))
		return 'e';
	while ((c = *p2))
	{
		if (c == '.')
			*p2 = '/';
		++p2;
	}
	sprintf(buf, "%s/%s", NEWSARTS, p1);
	free(p1);
	/*
	printf("\nIn %s, min = %d, max = %d\n", buf, mi, ma);
	*/
	if (chdir(buf) < 0)
		return '*';

	if (ex)
	{
		setsig(".overview.n");
		if (!(f1 = fopen(".overview.n", "w")))
		{
			setsig(NULL);
			return '!';
		}
		setlinebuf(f1);
		if ((f2 = fopen(".overview", "r")))
		{
			while (fgets(buf, sizeof(buf), f2))
			{
				i = atoi(buf);
				/*
				printf("Article %d entry\n", i);
				*/
				if (i < mi)
					goto expi;
				/* Make the minimum one more than the last entry found */
				mi = i + 1;
				sprintf(b2, "%d", i);
				/* If the corresponding article not found, expire it */
				if ((stat(b2, &st) < 0) || (!(S_ISREG(st.st_mode))))
					goto expi;
				/*
				printf("Copying the entry to the new overview file\n");
				*/
				++cop;
				while (1)
				{
					fputs(buf, f1);
					if (buf[strlen(buf) - 1] == '\n')
						break;
					if (!fgets(buf, sizeof(buf), f2))
						goto mkn;
				}
			}
			goto mkn;
		  expi:
			/* Expire it */
			/*
			printf("Expiring\n");
			*/
			++tot_exp;
			while (buf[strlen(buf) - 1] != '\n')
				if (!fgets(buf, sizeof(buf), f2))
					goto mkn;
		}
	  mkn:
		fclose(f2);
	}
	else
	{
		if (!(f1 = fopen(".overview", "a+")))
			return '!';
		setlinebuf(f1);
		rewind(f1);
		while (fgets(buf, sizeof(buf), f1))
		{
			/* Find the last article number already done */
			i = atoi(buf);
			if (i >= mi)
				mi = i + 1;
			while (buf[strlen(buf) - 1] != '\n')
				if (!fgets(buf, sizeof(buf), f1))
					goto mkm;
		}
	  mkm:
	}
	/* Now write new overview lines to f1 */
	if (ad)
		for (i = mi; i <= ma; ++i)
		{
			if ((p1 = mkover(i)))
			{
				fputs(p1, f1);
				fputc('\n', f1);
				free(p1);		/* Malloc'd by mkover */
				++tot_add;
				++add;
			}
		}
	fclose(f1);
	if (ex)
	{
		if (rename(".overview.n", ".overview") < 0)
		{
			unlink(".overview.n");
			setsig(NULL);
			return '!';
		}
		setsig(NULL);
	}
	if (verbose)
		printf("%d %d ", cop, add);
	return add ? '#' : (cop ? ':' : (ex ? '-' : '.'));
}
