#include "common.h"

#define LOCK "LOCKmkov"
static int locked=0;

/* Lock via a lockfile. Returns: 0 if successful,
   (pid) if already locked by pid, <0 on error. */

int lock(void)
{
  char f1[PATH_MAX], f2[PATH_MAX];
  int t=5;
  int i;
  FILE *f;

  sprintf(f1, "%s/L.%d", NEWSLIB, getpid());
  sprintf(f2, "%s/%s", NEWSLIB, LOCK);
  if (!(f=fopen(f1, "w")))
    return -1;
  fprintf(f, "%d\n", getpid());
  fclose(f);
  while (link(f1, f2)<0) {
    if ((f=fopen(f2, "r"))) {
      fscanf(f, "%d", &i);
      fclose(f);
      if (i && ((!kill(i, 0)) || (errno!=ESRCH))) {
	unlink(f1);
	return i; /* Is locked */
      }
      unlink(f2); /* Break stale lock */
    }
    if (!--t) {
      unlink(f1);
      return -1; /* Error */
    }
    sleep(2);
  }
  unlink(f1);
  locked=1;
  return 0;
}

int unlock(void)
{
  char f1[PATH_MAX];
  if (locked) {
    sprintf(f1, "%s/%s", NEWSLIB, LOCK);
    return (locked=unlink(f1));
  }
  return 0;
}
