#include "common.h"

/*
   Wrapper for testing the xover facility
   Simulates an nntp dialog
*/

int verbose=0;
int tot_grp=0, tot_add=0, tot_exp=0;
static int ingroup=0;

static void xov(char *a) 
{
  char *c;
  int mi, ma, i;

  if (sscanf(a, "%d-%d", &mi, &ma)!=2) {
    fputs("510 Usage: XOVER artno-artno\n", stdout);
  } else {
    fputs("221 overview lines follow\n", stdout);
    for (i=mi; i<=ma; ++i) {
      c=xo_xover(i);
      if (c) {
	fputs(c, stdout);
	fputc('\n', stdout);
      }
    }
    fputs(".\n", stdout);
  }
}

void main(int argc, char *argv[])
{
  int i, mi, ma;
  char buf[1024];
  char b2[1024];
  FILE *f;

  while ((i=getopt(argc, argv, "v"))>0) {
    switch(i) {
    case 'v': ++verbose; break;
    default: fprintf(stderr, "usage: %s [-v]\n", argv[0]); exit(127);
    }
  }
  setbuf(stdout, NULL);
  fputs("201 xover testing facility ready.\n", stdout);

  while(1) {
    if (!fgets(buf, sizeof(buf), stdin))
      break;
    buf[strlen(buf)-1]='\0';
    if (!strncasecmp(buf, "QUIT", 4))
      break;
    if (!strncasecmp(buf, "GROUP ", 5)) {
#if 0
      if (xo_group(buf+6)) {
	setsig(NULL);
	sprintf(b2, "awk '/^%s / {printf \"211 %%d %%d %%d %%s\\n\", $2-$3, $3, $2, $1}' %s/active", buf+6, NEWSLIB);
	system(b2); /* look away, this is a test program */
	ingroup=1;
      } else {
	fprintf(stdout, "411 Invalid group: %s\n", buf+6);
	ingroup=0;
      }
#else
      sprintf(b2, "grep '^%s ' %s/active", buf+6, NEWSLIB);
      if ((f=popen(b2, "r"))) {
	if (fscanf(f, "%*s %d %d %*s\n", &ma, &mi)==2) {
	  if (xo_group(buf+6, mi)) {
	    fprintf(stdout, "211 %d %d %d %s\n", ma-mi, mi, ma, buf+6);
	    pclose(f);
	    ingroup=1;
	    continue;
	  }
	}
	pclose(f);
      }
      fprintf(stdout, "411 Invalid group: %s\n", buf+6);
      ingroup=0;
#endif
      continue;
    }
    if (!strncasecmp(buf, "XOVER ", 5)) {
      if (ingroup) {
	xov(buf+6);
      } else {
	fputs("412 Not in a group\n", stdout);
      }
      continue;
    }
    fputs("500 What?\n", stdout);
  }
  fputs("205 Exiting.\n", stdout);
}
